#ifndef _Player_h
#include "Player.h"
#endif

#ifndef _Decode_h
#include "Decode.h"
#endif

#ifndef _NetworkInterface_h
#include "NetworkInterface.h"
#endif

#include "network.h"

Decode decodeur;

Player::Player(ScopeView* scopeView) :
	m_scopeView(scopeView),
	m_playVolume(1.0)
{
	// tell the network who is the player.
	CNetwork::Instance()->SetPlayer(this);
	NetworkInterface::Instance()->SetPlayer(this);


	m_player.Start();
	m_player.SetVolume(m_playVolume); 
}

Player::~Player()
{
	m_player.Stop();

	// tell the network that he is going to sleep
	CNetwork::Instance()->SetPlayer(NULL);
}

void
Player::Play(void* data)
{
/*	int nbr_skip = 4;
	
	if(Preferences::Instance()->UseModemQuality())
		nbr_skip = 6;
	if(Preferences::Instance()->UseCodec())
	{
		int size_of_buf;
		char* buffer = encodeur.createBuffer(size, size_of_buf, nbr_skip);
		encodeur.encodeBuffer(data, size, buffer, nbr_skip);
		decodeur.decodeBuffer(buffer, size_of_buf, data, nbr_skip);
		delete buffer;
	}
*/

/*	int16* j = (int16*)data;
	for (int i = 0; i < 100; i++)
		printf("%i", j[i]);
	printf("\n");
*/	
	if (!m_scopeView->IsShrink())
		m_scopeView->NewData( (int16*)data );

	BSound *sound; 
	BSoundPlayer::play_id id;

	media_raw_audio_format format;
	format.frame_rate = 44100;
	format.channel_count = 2;
	format.format = 0x2;
	format.byte_order = B_MEDIA_LITTLE_ENDIAN;
	format.buffer_size = 2048;

	sound = new BSound(data, 2048, format); 
	if (sound->InitCheck() == B_OK)
	{
		id = m_player.StartPlaying(sound); 
		sound->ReleaseRef();
	}
}


void
Player::PlayOld(void* data, size_t size)
{
	int nbr_skip = 2048 / size / 8;
	
	if(size != 2048)
	{
		size_t size_buf;
		char *buffer = (char*)data;

		void *result = decodeur.createBuffer(size, size_buf, nbr_skip);
		decodeur.decodeBuffer(buffer, size, result, nbr_skip);
		data = result;
		size = size_buf;	
	}

	if (!m_scopeView->IsShrink())
		m_scopeView->NewData( (int16*)data );

	BSound *sound; 
	BSoundPlayer::play_id id;

	media_raw_audio_format f;
	f.frame_rate = 44100;
	f.channel_count = 2;
	f.format = 0x2;
	f.byte_order = B_MEDIA_LITTLE_ENDIAN;
	f.buffer_size = size;

	sound = new BSound(data, size, f); 
	if (sound->InitCheck() == B_OK)
	{
		id = m_player.StartPlaying(sound); 
		sound->ReleaseRef();
	}
}


void
Player::SetPlayVolume(float volume)
{
	m_playVolume = volume;
	m_player.SetVolume(volume);
}
