#ifndef _SoundControlsView_h
#include "SoundControlsView.h"
#endif

#ifndef _Preferences_h
#include "Preferences.h"
#endif

#ifndef _Def_h
#include "Def.h"
#endif


SoundControlsView::SoundControlsView(BRect AFrame, bool bShrink)
	: ShrinkView(AFrame, "Sound Controls", bShrink)
{
	rgb_color color = {192, 192, 192, 0};
	SetViewColor(color);

	//Adding MicroSlider
	m_pSlider = new BSlider(BRect(5, 20, AFrame.right - 50, 0), "MicroSlider", NULL, new BMessage(MSG_SOUNDCONTROLS_VOLUME), 0, 100, B_TRIANGLE_THUMB, B_FOLLOW_RIGHT);
	m_pSlider->SetHashMarks(B_HASH_MARKS_TOP); 
	m_pSlider->SetHashMarkCount(10);
	m_pSlider->SetBarColor(kLightBlue);
	m_pSlider->UseFillColor(true, &kRed);
	AddChild(m_pSlider);

	// Adding MicroMuteCheckBox
	m_pMuteCheckBox = new BCheckBox(BRect(AFrame.right - 50, 17, AFrame.right - 5, 0), "MuteCheckBox", "Mute", new BMessage(MSG_SOUNDCONTROLS_MUTE), B_FOLLOW_RIGHT);
	AddChild(m_pMuteCheckBox);


	m_pSlider->SetModificationMessage(new BMessage(MSG_SOUNDCONTROLS_VOLUME));
}


SoundControlsView::~SoundControlsView()
{
}


void
SoundControlsView::MessageReceived(BMessage* msg)
{
	switch (msg->what)
	{
		case MSG_SOUNDCONTROLS_MUTE:
			m_pSlider->SetEnabled(!(bool)(m_pMuteCheckBox->Value() == B_CONTROL_ON));
			Window()->MessageReceived(msg);
			break;
		default:
			BView::MessageReceived(msg);
			break;
	}
}

void
SoundControlsView::AllAttached()
{
	m_pSlider->SetTarget(this);
	m_pMuteCheckBox->SetTarget(this);
}
