#ifndef _CLIENT_H
#include "client.h"
#endif

#ifndef _Preferences_h
#include "Preferences.h"
#endif


TClient* TClient::m_instance = 0;

TClient::TClient() :
	m_bIsOnline(false)
{
	m_remoteAddress_size = sizeof (m_remoteAddress);

	my_thread = -1;
	
   	cmd_lock = create_sem(1, "CMD lock");
	result_lock = create_sem(1, "RECV lock");
}

TClient::~TClient ()
{
	delete_sem(cmd_lock);
	delete_sem(result_lock);
}

TClient* TClient::Instance()
{
	if (!m_instance)
		m_instance = new TClient;
	return m_instance;
}



char* TClient::GetIPByEmail(char *email){
	char cmd[1024];
	strcpy(cmd, "find ");
	strcat(cmd, email);
	strcat(cmd, ";");
	SendCmd(cmd);
	return GetResult();
}

char* TClient::GetIPByName(char *last_name, char* first_name){
	char cmd[1024];
	strcpy(cmd, "find ");
	strcat(cmd, last_name);
	strcat(cmd, "|");
	strcat(cmd, first_name);
	strcat(cmd, ";");
	SendCmd(cmd);
	return GetResult();
}

char* TClient::GetFirstNameByIP(char *ip){
	char cmd[1024];
	strcpy(cmd, "getFirstName ");
	strcat(cmd, ip);
	strcat(cmd, ";");
	SendCmd(cmd);
	return GetResult();
}

char* TClient::GetLastNameByIP(char *ip){
	char cmd[1024];
	strcpy(cmd, "getLastName ");
	strcat(cmd, ip);
	strcat(cmd, ";");
	SendCmd(cmd);
	return GetResult();
}

char* TClient::GetEmailByIP(char *ip){
	char cmd[1024];
	strcpy(cmd, "getEmail ");
	strcat(cmd, ip);
	strcat(cmd, ";");
	SendCmd(cmd);
	return GetResult();
}

bool TClient::Register(char *last_name, char *first_name, char *email){
	if(Go())
	{
		char cmd[1024];
		strcpy(cmd, "info ");
		strcat(cmd, last_name);
		strcat(cmd, "|");
		strcat(cmd, first_name);
		strcat(cmd, "|");
		strcat(cmd, email);
		strcat(cmd, ";");
		SendCmd(cmd);
		
		m_bIsOnline = true;

		return true;
	}
	return false;
}

void TClient::Deregister()
{
	SendCmd("del;");
	m_bIsOnline = false;
}


int TClient::ConnectTCP ()
{
	//printf("ConnectTCP\n");
	m_sStream = socket (AF_INET, SOCK_STREAM, 0);  // orienter connection

	// etablie la connection dans le socket orienter connection
	if (connect (m_sStream, (const struct sockaddr*)&m_remoteAddress, m_remoteAddress_size) != 0)
	{
		return -1;
	}

	//printf("Connected with %s\n", inet_ntoa (m_remoteAddress.sin_addr));

	return 0;
}

void TClient::Cmd()
{
	int redo = 1;	
	do
	{	
		char *sendbuffer = new char[strlen(CMD)];
		strcpy(sendbuffer, CMD);
		if(send(m_sStream, sendbuffer, strlen(sendbuffer), 0 ) < 0)
		{
			printf("error send\n");
			break;
		}
		delete sendbuffer;

		if(strcmp(CMD, "del;"))
		{
			if(strstr(CMD, "alive;") == NULL && strstr(CMD, "info") == NULL)
			{
				int length = 0;
				char aChar = ' ';
				if(recv(m_sStream, &length, sizeof(char), 0 ) < 0)
				{
					printf("error read length");
					break;
				}
				else 
				{
					RESULT = new char[length + 1];
					int i = 0;
					while(i < length)
					{				
						if(recv(m_sStream, &aChar, sizeof(char), 0 ) < 0)
						{
							printf("error read");
							redo = 0;
							break;
						}
						else
						{
							RESULT[i] = aChar;
							i++;
						}
					}
					RESULT[i] = '\0';
					printf("result: %s\n", RESULT);
				}
			}
				
			redo = 1;
			strcpy(CMD, "alive;");
			release_sem(cmd_lock);
			release_sem(result_lock);
			
			snooze(50 * 1000 * 1000);
		}
		else
		{
			redo = 0;
		}
	}
	while (redo);

	closesocket(m_sStream);
	my_thread = -1;	
}

void TClient::SendCmd(char *cmd)
{
	if (my_thread != -1)
	{
		acquire_sem(cmd_lock);
		acquire_sem(result_lock);
		strcpy(CMD, cmd);
		suspend_thread(my_thread);
		resume_thread(my_thread);
	}
}

char* TClient::GetResult()
{
	acquire_sem(result_lock);
	char *result = new char[strlen(RESULT)];
	strcpy(result, RESULT);
	RESULT = NULL;
	release_sem(result_lock);
	return result;
}

bool TClient::Go()
{
	if(my_thread != -1)
		return true;

	m_remoteAddress.sin_family = AF_INET;
	m_remoteAddress.sin_port = htons(Preferences::Instance()->ServerPort());
	m_remoteAddress.sin_addr.s_addr = inet_addr(Preferences::Instance()->ServerIP());

	CMD = new char[1024];
	strcpy(CMD, "alive;");	

	if (ConnectTCP() == 0)
	{   
		my_thread = spawn_thread(&Cmd, "Cmd Thread", 10, this); 
		resume_thread(my_thread);
		return true;
	}

	return false;
}
