#ifndef _ConnectView_h
#include "ConnectView.h"
#endif

#ifndef _BeNetMenu_h
#include "BeNetMenu.h"
#endif

#ifndef _BookmarkItem_h_
#include "BookmarkItem.h"
#endif

#ifndef _Def_h
#include "Def.h"
#endif

#ifndef _Network
#include "network.h"
#endif

#ifndef _WaitWindow_h
#include "WaitWindow.h"
#endif

#ifndef _CLIENT_H
#include "client.h"
#endif

#ifndef _BitmapCatalog_h
#include "BitmapCatalog.h"
#endif

#include <Message.h>
#include <Alert.h>

#include <string.h>


ConnectView::ConnectView(BRect frame, bool bShrink) :
	ShrinkView(frame, "Connection", bShrink/*, BitmapCatalog::Instance()->FetchBitmap("Bitmaps/ShrinkView2.tif", true)*/)
{
	SetViewColor(192,192,192);
}

ConnectView::~ConnectView()
{

}

void
ConnectView::AttachedToWindow()
{
	m_pRadioPersonal = new BRadioButton(BRect(5, 20, 50, 40), "Personal_info",
	 												"Using Personal Information",
	 												 new BMessage(MSG_CONNECTION_MODE),
	 												 B_FOLLOW_NONE, B_WILL_DRAW);
	m_pRadioPersonal->SetTarget(this);
	 												 
	m_pRadioIP = new BRadioButton(BRect(5, 180, 50, 200), "Ip_adress",
											  "Using IP Adress",
											  new BMessage(MSG_CONNECTION_MODE),
											  B_FOLLOW_NONE, B_WILL_DRAW);
	m_pRadioIP->SetTarget(this);
	
	m_pBoxPersonal = new BBox(BRect(5, 20, 225, 135), "BoxPersonal", B_FOLLOW_NONE, B_WILL_DRAW, B_FANCY_BORDER);
	m_pBoxIP = new BBox(BRect(5, 140, 225, 190), "BoxIP", B_FOLLOW_NONE, B_WILL_DRAW, B_FANCY_BORDER);

	m_pBoxPersonal->SetLabel(m_pRadioPersonal);
	m_pBoxIP->SetLabel(m_pRadioIP);

	m_pConnect = new BButton(BRect(160,195,225,215), "Connect", "Connect", new BMessage(MSG_MENU_CONNECT));	
	
	m_pBoxPersonal->AddChild(m_pFirstName = new BTextControl(BRect(5, 20, 210, 35), "ConnectName", "First name", NULL, 0, B_FOLLOW_NONE, B_WILL_DRAW));
	m_pFirstName->SetDivider(60);

	m_pBoxPersonal->AddChild(m_pLastName = new BTextControl(BRect(5,40,210,55), "ConnectName", "Last name", NULL, 0, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE));
	m_pLastName->SetDivider(60);
	
	m_pBoxPersonal->AddChild(m_pEmail = new BTextControl(BRect(5, 60, 210, 75), "ConnectName", "Email", NULL, 0, B_FOLLOW_NONE, B_WILL_DRAW));
	m_pEmail->SetDivider(60);
	
	m_pBoxIP->AddChild(m_pIP = new BTextControl(BRect(5,20,210,40), "ConnectIP", "IP Address", NULL, 0, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE));
	m_pIP->SetDivider(60);

	AddChild(m_pBoxPersonal);
	AddChild(m_pBoxIP);
	AddChild(m_pConnect);

	BuildShortcutMenu();

	m_pRadioPersonal->SetValue(0);
	m_pRadioIP->SetValue(1);
	m_pRadioPersonal->SetEnabled(false);
	m_pLastName->SetEnabled(false);
	m_pFirstName->SetEnabled(false);
	m_pEmail->SetEnabled(false);
	m_pIP->SetEnabled(true);
}


void
ConnectView::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
   		case MENU_BOOKMARKS:
   		{
   			char *v_pString = new char[256];
   			strcpy(v_pString, (char*)message->FindString("Bookmark"));
						
			m_pBookmarkItem = Bookmarks::Instance()->FindBookmarkItem(v_pString);			

			m_pLastName->SetText(m_pBookmarkItem->GetColumnContentText(0));
			m_pFirstName->SetText(m_pBookmarkItem->GetColumnContentText(1));
			m_pEmail->SetText(m_pBookmarkItem->GetColumnContentText(2));
   			
   			delete v_pString;
   			break;
   		}
   		case MSG_MENU_SAVE:
   		{
   			delete m_pBookmarksShortcut;
   			RemoveChild(m_pShortcutField);
   			BuildShortcutMenu();
   			break;
   		}
   		case MSG_CONNECTION_MODE:
			m_pFirstName->SetEnabled((bool)m_pRadioPersonal->Value());
			m_pLastName->SetEnabled((bool)m_pRadioPersonal->Value());
			m_pEmail->SetEnabled((bool)m_pRadioPersonal->Value());
			m_pShortcutField->SetEnabled((bool)m_pRadioPersonal->Value());
			m_pIP->SetEnabled((bool)m_pRadioIP->Value());
   			break;
   		default:
   			BView::MessageReceived(message);
			break;
	}
}


void
ConnectView::BuildShortcutMenu()
{
	m_pBookmarksShortcut = new BookmarksShortcut();
	m_pBookmarksShortcut->SetRadioMode(true);
	
	m_pBoxPersonal->AddChild(m_pShortcutField = new BMenuField(BRect(5, 85, 200, 90), "shortcutField", NULL, m_pBookmarksShortcut));
	m_pShortcutField->SetEnabled((bool)m_pRadioPersonal->Value());
}


status_t
ConnectView::Connect()
{
	if (IsServerNeeded())
	{
		// Demandons au serveur l'adresse de l'usager choisi
		// On demande en premier avec l'email : GetEmail().
		// Si ca ne fonctionne pas, on demande avec le nom: GetFirstName() & GetLastName().
		
		char* ip = TClient::Instance()->GetIPByEmail(GetEmail());
		if (!strcmp(ip, "null"))
		{
			ip = TClient::Instance()->GetIPByName(GetLastName(), GetFirstName());
			if (!strcmp(ip, "null"))
			{
				BAlert *myAlert = new BAlert(	"Error", "User not found (maybe not online).\n  Please try again later.",
												"Ok", NULL, NULL, 
												B_WIDTH_AS_USUAL, B_EVEN_SPACING, B_STOP_ALERT); 
				myAlert->Go();

				return false;
			}
		}

/*		WaitWindow* waitWindow = new WaitWindow;
		waitWindow->Show();
		waitWindow->SetText(ip);*/
		return CNetwork::Instance()->ConnectFromUI(inet_addr(ip));
	}
	else
	{
/*		WaitWindow* waitWindow = new WaitWindow;
		waitWindow->Show();
		waitWindow->SetText(GetIP());*/

		// On demande directement au reseau de nous connecter avec l'adresse dans GetIP().
		return CNetwork::Instance()->ConnectFromUI(inet_addr(GetIP()));
	}
	
	return true; // temporaire
}


void
ConnectView::Online()
{
	m_pRadioPersonal->SetEnabled(true);
}


void
ConnectView::Offline()
{
	m_pRadioPersonal->SetEnabled(false);
	m_pRadioPersonal->SetValue(0);

	m_pRadioIP->SetValue(1);

	MessageReceived(new BMessage(MSG_CONNECTION_MODE));
}

