#ifndef _PreferencesWindow_h
#include "PreferencesWindow.h"
#endif

#ifndef _PreferencesViews_h
#include "PreferencesViews.h"
#endif

#ifndef Preferences_h
#include "Preferences.h"
#endif

#include <TabView.h>


PreferencesWindow::PreferencesWindow() 
	: BWindow(BRect(0,0,280,125), "Preferences", B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
	BTab *tab; 

	BRect r = Bounds(); 
	BTabView* tabView = new BTabView(r, "tab_view"); 
	tabView->SetViewColor(216,216,216,0); 
	r = tabView->Bounds(); 
	r.bottom -= tabView->TabHeight(); 

	tab = new BTab(); 
	tabView->AddTab(new GeneralPreferencesView(r), tab); 
	tab->SetLabel("General"); 

	tab = new BTab(); 
	tabView->AddTab(new AudioPreferencesView(r), tab); 
	tab->SetLabel("Audio");

	tab = new BTab(); 
	tabView->AddTab(new NetworkPreferencesView(r), tab); 
	tab->SetLabel("Network");

	tab = new BTab(); 
	tabView->AddTab(new IdentityPreferencesView(r), tab); 
	tab->SetLabel("Identity");

	AddChild(tabView);
	tabView->SetTabWidth(B_WIDTH_FROM_WIDEST);

	MoveTo(	Preferences::Instance()->PreferencesX(),
			Preferences::Instance()->PreferencesY());
}



bool
PreferencesWindow::QuitRequested(void)
{
	Hide();
	return false;
}


void
PreferencesWindow::FrameMoved(BPoint point)
{
	Preferences::Instance()->PreferencesX(point.x);
	Preferences::Instance()->PreferencesY(point.y);
}
